function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import Book from "./book/book";
import Rendition from "./rendition/rendition";
import EpubCFI from "./utils/epubcfi";
import Contents from "./rendition/contents";
import * as utils from "./utils/core";
import { EPUBJS_VERSION } from "./utils/constants";
import "../libs/url/url-polyfill";
import IframeView from "./managers/views/iframe";
import DefaultViewManager from "./managers/default/index";
import ContinuousViewManager from "./managers/continuous/index";
import Epub from './epub/epub';
import EpubBridge from './epub/bridge';
/**
 * Creates a new Book or Book Bridge & Worker
 * @param {string|ArrayBuffer} url URL, Path or ArrayBuffer
 * @param {object} options to pass to the book
 * @returns {Book} a new Book object
 * @example ePub("/path/to/book.epub", {})
 */

function ePub(_x) {
  return _ePub.apply(this, arguments);
}

function _ePub() {
  _ePub = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(url) {
    var options,
        epub,
        rendition,
        _args = arguments;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};

            if (!(_args.length === 0 || _args.length === 1 && _typeof(_args[0]) === "object")) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return", _construct(Epub, Array.prototype.slice.call(_args)));

          case 3:
            if (options.worker) {
              epub = new EpubBridge(options);
            } else {
              epub = new Epub(options);
            }

            return _context.abrupt("return", epub.open(url).then(function (book) {
              /**
               * Sugar to render a book to an element
               * @param  {element | string} element element or string to add a rendition to
               * @param  {object} [options]
               * @return {Rendition}
               */
              book.renderTo = function (element) {
                var renditionOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

                if (options && typeof options.worker !== "undefined" && typeof renditionOptions.worker === "undefined") {
                  renditionOptions.worker = options.worker;
                }

                rendition = new Rendition(book.manifest, renditionOptions);
                rendition.renderTo(element); // If the workers fails, switch to replacements

                rendition.on("workerFailed", function () {
                  rendition.clear();
                  epub.replacements().then(function (book) {
                    rendition.unpack(book.manifest);
                    rendition.display(rendition.location);
                  });
                });
                return rendition;
              };

              book.generateLocations = function (chars) {
                return epub.generateLocations(chars).then(function (locations) {
                  book.locations = locations;
                  return locations;
                });
              };

              book._destroy = book.destroy;

              book.destroy = function () {
                book._destroy();

                epub.destroy();
                rendition.destroy();
              }; // epub.destroy();


              book.epub = epub;
              return book;
            }));

          case 5:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _ePub.apply(this, arguments);
}

ePub.VERSION = EPUBJS_VERSION;
ePub.CFI = EpubCFI;
ePub.Book = Book;
ePub.Rendition = Rendition;
ePub.Contents = Contents;
ePub.utils = utils;
ePub.Epub = Epub;
ePub.EpubBridge = Epub;
export default ePub;