"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _resourcelist = _interopRequireDefault(require("./resourcelist.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/**
 * 
 */
class Locator {
  constructor(item = {}) {
    this.data = {
      url: item.url,
      index: item.index,
      id: item.id,
      cfi: item.cfi,
      type: item.type,
      name: item.name,
      parent: undefined,
      children: new _resourcelist.default()
    };
  }
  get url() {
    return this.data.url;
  }
  set url(url) {
    this.data.url = url;
  }
  get index() {
    return this.data.index;
  }
  set index(index) {
    this.data.index = index;
  }
  get id() {
    return this.data.id;
  }
  set id(id) {
    this.data.id = id;
  }
  get cfi() {
    return this.data.cfi;
  }
  set cfi(cfi) {
    this.data.cfi = cfi;
  }
  get type() {
    return this.data.type;
  }
  set type(type) {
    this.data.type = type;
  }
  get name() {
    return this.data.name;
  }
  set name(name) {
    return this.data.name;
  }
  get parent() {
    return this.data.parent;
  }
  set parent(item) {
    this.data.parent = item;
    return this.data.parent;
  }
  get children() {
    return this.data.children;
  }
  set children(items) {
    for (const childItem of items) {
      const child = new Locator(childItem);
      child.parent = this;
      this.children.append(child);
    }
    return this.data.children;
  }
  toJSON() {
    return JSON.stringify(this);
  }
  destroy() {}
}
var _default = Locator;
exports.default = _default;